Status: Third Party's Issue   

Priority: Normal   

Assignee:    

Description

fork(2)

Windows already has related features like CreateProcess, but for servers and workers fork is required for source code compatibility

of existing scripts,

which are written for Unix.

nonblocking IO

To check socket's availability by IO#read_nonblock https://github.com/ruby/ruby/pull/1089

O_NONBLOCK

Signal

Windows doesn't support true Signal.

https://msdn.microsoft.com/en-us//library/xdkz3x12.aspx

tz

Get IANA timezone name of current timezone from OS.

Remove a file which is opened by another process

If the process opens the file with CreateFile with FILE_SHARE_DELETE flag, another process can remove the file.

But in that case processes can't remove its parent folder.

https://bugs.ruby-lang.org/issues/11218

symlink

Windows has mklink and SeCreateSymbolicLinkPrivilege, but it has some limitations.

http://k-takata.o.oo7.jp/diary/2013-04.html#03

https://twitter.com/n0kada/status/570232516545638400

[Bug #18882] On 64-mingw-ucrt, File.read() sometimes doesn't read entire file

(alanwu)

https://github.com/ruby/dev-meeting-log/blob/master/DevMeeting-2022-07-21.md#bug-18882-on-64-mingw-ucrt-fileread-sometimes-

doesnt-read-entire-file-alanwu

fd

Generic handling of file, pipe, socket by fd

fd passing to child process other than 0,1,2

Get access mode from fd/HANDLE

System side append mode

https://bugs.ruby-lang.org/issues/18605

a high performance selector API
https://tonyarcieri.com/a-gentle-introduction-to-nio4r

socket

CloseHandle should work with socket.

writev(2)

https://twitter.com/okuoku/status/670212493134852097

https://msdn.microsoft.com/ja-jp/library/windows/desktop/aa365749%28v=vs.85%29.aspx

ANSI color code

http://srad.jp/story/16/02/09/0639223/

UNIXSocket

We can emuate UNIXSocket with named pipe?

Implemented [Feature #19135]

History

#1 - 06/09/2016 01:16 PM - k_takata (Ken Takata)

http://homepage3.nifty.com/k-takata/diary/2013-04.html#03

 This page was moved to:

http://k-takata.o.oo7.jp/diary/2013-04.html#03

#2 - 06/09/2016 06:11 PM - naruse (Yui NARUSE)

- Description updated

This page was moved

 Thank! fixed.

#3 - 06/10/2016 01:27 PM - nobu (Nobuyoshi Nakada)

- Description updated

#4 - 07/12/2016 05:11 PM - naruse (Yui NARUSE)

- Description updated

#5 - 05/25/2018 08:48 PM - emk (Masatoshi Kimura)

Remove a file which is opened by another process

 Fall Creators Update added FILE_DISPOSITION_POSIX_SEMANTICS.

https://docs.microsoft.com/en-us/windows-hardware/drivers/ddi/content/ntddk/ns-ntddk-_file_disposition_information_ex

UNIXSocket

 April 2018 Update added AF_UNIX sockets.

https://blogs.msdn.microsoft.com/commandline/2018/02/07/windowswsl-interop-with-af_unix/

Just FYI, I did not test them.
#6 - 08/17/2018 06:54 AM - naruse (Yui NARUSE)

- Description updated

#7 - 01/17/2020 06:10 AM - naruse (Yui NARUSE)

- Tags set to win

#8 - 11/17/2022 08:10 PM - ioquatix (Samuel Williams)

UNIXSocket is implemented in https://bugs.ruby-lang.org/issues/19135

#9 - 12/15/2022 08:08 AM - naruse (Yui NARUSE)

- Description updated

#10 - 12/27/2022 03:00 PM - naruse (Yui NARUSE)

- Description updated
